function psSplit( aURI )
{
    var arrayResult = new Array( aURI, "", "" );
    var re = /[\s\"\'\\]/;
    for( var i=0; i < aURI.length; i++ )
    {
	var c = aURI.charAt(i);
	if( !re.test( c ) )
	{
	    arrayResult[0] = aURI.substring( 0, i );
	    arrayResult[1] = aURI.substring( i );
	    break;
	}
    }

    for( var i = arrayResult[1].length-1; i >= 0 ; i-- )
    {
	var c = arrayResult[1].charAt(i);
	if( !re.test( c ) )
	{
	    arrayResult[2] = arrayResult[1].substring( i + 1 );
	    arrayResult[1] = arrayResult[1].substring( 0, i + 1 );
	    break;
	}
    }

    return arrayResult;
}//psSplit()

function psGetProtocol( aURI )
{
    var i = aURI.indexOf( '://' );

    if ( i != -1 )
    {
	var protocol = aURI.substr( 0, i )
	var arrayOfStrings = protocol.split(/[^\w]/);

	if( arrayOfStrings != null && arrayOfStrings.length == 1 )
	{
	    return protocol;
	}
    }

    return -1;
}//psGetProtocol()

function psGetDefaultPort( aProtocol )
{
    var lProtocol = aProtocol.toLowerCase();

    if ( lProtocol.indexOf( 'https' ) == 0 )
    {
	return 443;
    }

    if ( lProtocol.indexOf( 'http' ) == 0 )
    {
	return 80;
    }

    return -1;
}//psGetDefaultPort()

function psGetNetworkURI( aURI )
{
    var lURI = aURI;
    var bProtocolIndex = lURI.indexOf( '://' ) + 3;
    var bSearchPart = lURI.substr( bProtocolIndex );

    //search for / or / or # in the order & take the least one
    var bIndex =  bSearchPart.indexOf( '/' );
    if ( bIndex != -1 )
    {
	bSearchPart = bSearchPart.substr( 0, bIndex );

	var bQueryIndex = bSearchPart.indexOf( '?' );
	if( bQueryIndex != -1 )
	{
	    bIndex = bQueryIndex;
	}
	else
	{
	    var bReferenceIndex = bSearchPart.indexOf( '#' )
	    if( bReferenceIndex != -1 )
	    {
		bIndex = bReferenceIndex;
	    }
	}
    }
    else
    {
	var bQueryIndex = bSearchPart.indexOf( '?' );
	if( bQueryIndex != -1 )
	{
	    bIndex = bQueryIndex;
	}
	else
	{
	    var bReferenceIndex = bSearchPart.indexOf( '#' )
	    if( bReferenceIndex != -1 )
	    {
		bIndex = bReferenceIndex;
	    }
	}
    }

    if ( bIndex != -1 )
    {
	return lURI.substr( 0, bProtocolIndex + bIndex );
    }

    return lURI;
}//psGetNetworkURI()

function psNormalizePort( aURI, aDefaultPort )
{
    var lURI = aURI;

    //absoute url
    var bDefaultPortString = ':' + aDefaultPort;
    var bNetworkURI = psGetNetworkURI( lURI );
    var bRest = lURI.substr( bNetworkURI.length );
    var bPortIndex = bNetworkURI.indexOf( bDefaultPortString );
    var bCalPortIndex = bNetworkURI.length - bDefaultPortString.length;

    if (  ( bPortIndex != -1 ) &&
	  ( bPortIndex == bCalPortIndex ) )
    {
	return bNetworkURI.substr( 0, bPortIndex ) + bRest;
    }

    return lURI;
}//psNormalizePort()

//New functions
function psEndsWith( aSource, aMatch )
{
    var index = aSource.lastIndexOf( aMatch );
    if( ( index != -1 ) &&
        ( index + aMatch.length == aSource.length ) )
    {
        return true;
    }
                                                                                                 
    return false;
}//psEndsWith()

function psGetHostAndPort( aString )
{
    //hostName, host, port
    var arrayResult = new Array( "", "", "" );

    var bSearchPart = aString;

    //search for / or ? or # in the order & take the least one
    var bIndex =  bSearchPart.indexOf( '/' );
    if ( bIndex != -1 )
    {
        bSearchPart = bSearchPart.substr( 0, bIndex );

        var bQueryIndex = bSearchPart.indexOf( '?' );
        if( bQueryIndex != -1 )
        {
            bIndex = bQueryIndex;
        }
        else
        {
            var bReferenceIndex = bSearchPart.indexOf( '#' );
            if( bReferenceIndex != -1 )
            {
                bIndex = bReferenceIndex;
            }
        }
    }
    else
    {
        var bQueryIndex = bSearchPart.indexOf( '?' );
        if( bQueryIndex != -1 )
        {
            bIndex = bQueryIndex;
        }
        else
        {
            var bReferenceIndex = bSearchPart.indexOf( '#' )
            if( bReferenceIndex != -1 )
            {
                bIndex = bReferenceIndex;
            }
        }
    }

    //if / or ? or # not present, entire thing is host name
    if ( bIndex == -1 )
    {
        bIndex = aString.length;
    }

    var hostName = aString.substr(0, bIndex);
    arrayResult[0] = hostName;

    bIndex = hostName.indexOf(':');
    if( bIndex == -1 )
    {
        arrayResult[1] = hostName;
    }
    else
    {
        arrayResult[1] = hostName;
        arrayResult[2] = hostName.substr( bIndex + 1 );
    }

    return arrayResult;
}//psGetHostAndPort()
 
function psGetPath( aString )
{
    var lIndex = aString.indexOf('#');

    if( lIndex == -1 )
    {
        lIndex = aString.indexOf('?');
    }

    if( lIndex == -1 )
    {
        lIndex = aString.length;
    }

    return aString.substr( 0, lIndex );
}//psGetPath()

function psGetReference( aString )
{
    if( aString.charAt( 0 ) == '#' )
    {
        var bIndex = aString.indexOf('?');
        if( bIndex != -1 )
        {
            return aString.substr( 1, bIndex-1 );
        }
        else
        {
            return aString.substr( 1 );
        }
    }

    return "";
}//psGetReference()

function psGetQuery( aString )
{
    if( aString.charAt( 0 ) == '?' )
    {
        return aString.substr( 1 );
    }

    return "";
}//psGetQuery();

function URIObject( aAbsoluteURI )
{
    this.input = aAbsoluteURI;

    var lString = aAbsoluteURI;
    this.protocol = psGetProtocol( lString );
    this.defaultPort = psGetDefaultPort( this.protocol );

    lString = lString.substring( this.protocol.length + '://'.length );
    var lResult = psGetHostAndPort( lString );
    this.hostName = lResult[0];
    this.host = lResult[1];
    this.port = lResult[2];

    lString = lString.substring( this.hostName.length );
    this.path = psGetPath( lString );

    lString = lString.substring( this.path.length );
    this.reference = psGetReference( lString );

    this.query = '';
    if( this.reference.length != 0 )
    {
        lString = lString.substring( '#'.length + this.reference.length );
    }
    this.query = psGetQuery( lString );

    this.networkURI = '';
    if( this.protocol.length !=  0 )
    {
        this.networkURI = this.protocol + '://' + this.hostName;
    }

    //use old psNormalizePort function
    //this.normalizedURI = psNormalizePort( this.input, this.defaultPort, this.networkURI );
    this.normalizedURI = psNormalizePort( this.input, this.defaultPort );
}//URIObject()

function CustomLocation( aAbsoluteURI )
{
 if (psGetProtocol(aAbsoluteURI) != -1)
 {
    var lURIObject = new URIObject( aAbsoluteURI );
    this.protocol = lURIObject.protocol + ':';
    this.hostname = lURIObject.hostName;
    this.host = lURIObject.host;
    this.port = lURIObject.port;
    this.pathname = lURIObject.path;

    this.hash = '';
    if(lURIObject.reference.length != 0 )
    {
        this.hash = '#' + lURIObject.reference;
    }

    this.search = '';
    if(lURIObject.query.length != 0 )
    {
        this.search = '?' + lURIObject.query;
    }
  }
}//CustomLocation()
